import java.util.*;
import java.io.*;
import static choco.Choco.*;
import choco.cp.model.CPModel;
import choco.cp.solver.CPSolver;
import choco.kernel.model.Model;
import choco.kernel.model.constraints.Constraint;
import choco.kernel.solver.Solver;
import choco.kernel.model.variables.integer.IntegerVariable;
import choco.kernel.solver.variables.integer.IntDomainVar;
import choco.kernel.solver.ContradictionException;
import choco.cp.solver.search.integer.varselector.StaticVarOrder;
import choco.cp.solver.search.integer.varselector.MinDomain;

public class Solve {

    public static void main(String[] args) throws FileNotFoundException, IOException, Exception {
	String fname           = args[0];
	CSP csp                = new CSP(fname);	
	int n                  = csp.getNoCars();
	Model modl             = csp.getModel();	
	CPSolver sol           = csp.getSolver();
	IntDomainVar [] decVar = sol.getVar(csp.getPosition());
	sol.setVarIntSelector(new MinDomain(sol,decVar));
	if (args.length > 1) sol.setNodeLimit(Integer.parseInt(args[1]));
	if (sol.solve(false) != null)
	    for (int i=0;i<n;i++) System.out.println(decVar[i].getVal());
	if (args.length > 2) System.out.println(csp);
	System.out.println("nodes: "+ sol.getNodeCount() +" solveTime:  "+ sol.getTimeCount());
    }
}
